#include <math.h>
#include "mlvalues.h"
#include "alloc.h"
#include "fail.h"

extern int errno;

value string_of_float(f)  /* ML */
     value f;
{
#define NBR_DIGITS 15           /* A revoir */

  char buff[NBR_DIGITS+25];

  errno = 0;
  gcvt(CFLOAT(f), NBR_DIGITS, buff);
  if (errno != 0) failwith("string_of_float");
  return alloc_string(buff);
}

value float_of_string(s)        /* ML */
     value s;
{
  extern double atof();
  return alloc_double(atof(CSTRING(s)));
}

value exp_float(f)              /* ML */
     value f;
{
  return alloc_double(exp(CFLOAT(f)));
}

value log_float(f)              /* ML */
     value f;
{
  return alloc_double(log(CFLOAT(f)));
}

value sqrt_float(f)             /* ML */
     value f;
{
  return alloc_double(sqrt(CFLOAT(f)));
}

value power_float(f, g)         /* ML */
     value f, g;
{
  return alloc_double(pow(CFLOAT(f), CFLOAT(g)));
}

value sin_float(f)              /* ML */
     value f;
{
  return alloc_double(sin(CFLOAT(f)));
}

value cos_float(f)              /* ML */
     value f;
{
  return alloc_double(cos(CFLOAT(f)));
}

value tan_float(f)              /* ML */
     value f;
{
  return alloc_double(tan(CFLOAT(f)));
}

value asin_float(f)             /* ML */
     value f;
{
  return alloc_double(asin(CFLOAT(f)));
}

value acos_float(f)             /* ML */
     value f;
{
  return alloc_double(acos(CFLOAT(f)));
}

value atan_float(f)             /* ML */
     value f;
{
  return alloc_double(atan(CFLOAT(f)));
}

value atan2_float(f, g)        /* ML */
     value f, g;
{
  return alloc_double(atan2(CFLOAT(f), CFLOAT(g)));
}

