#include "mlvalues.h"
#include "alloc.h"
#include "fail.h"

unsigned char *itoa (buf, num)
     unsigned char buf [13];
     long num;
{
  unsigned char * i;
  unsigned long n;

  i = buf + 12;
  *i = '\0';
  if (num < 0) n = -num; else n = num;
  do {
    *--i = n % 10 + '0';
    n = n / 10;
  } while (n > 0);
  if (num < 0) *--i = '-';
  return i;
}

value string_of_int(i)          /* ML */
     value i;
{
  unsigned char buff[13];
  unsigned char * p;
  int n;
  value res;

  p = itoa(buff, CINT(i));
  n = strlen(p);
  ALLOC_STRING(res, n);
  bcopy(p, CSTRING(res), n);
  return res;
}

value int_of_string(s)          /* ML */
     value s;
{
  long res;
  int sign;
  unsigned char * p;

  p = CSTRING(s);
  if (*p == '-') {
    sign = -1;
    p++;
  } else {
    sign = 1;
  }
  for (res = 0; *p >= '0' && *p <= '9'; p++) {
    res = 10 * res + *p - '0';
  }
  if (*p != 0)
    failwith("int_of_string");
  return MLINT(sign < 0 ? -res : res);
}
