/* io.h : entrees/sorties bufferisees */

#include "unaligned.h"

#ifndef IO_BUFFER_SIZE
#define IO_BUFFER_SIZE 8192
#endif

struct channel {
  int fd;	                /* Descripteur de fichier UNIX */
  unsigned char * curr;         /* Position courante dans le buffer */
  unsigned char * max;          /* Fin logique du buffer */
  unsigned char * end;          /* Fin physique du buffer */
  unsigned char buff[IO_BUFFER_SIZE]; /* Le buffer lui-meme */
};

#define putc(channel, ch)                                                     \
  { if ((channel)->curr >= (channel)->end) flush(channel);                    \
    *((channel)->curr)++ = (ch);                                              \
    if ((channel)->curr > (channel)->max) (channel)->max = (channel)->curr; }

#define getc(channel)                                                         \
  ((channel)->curr >= (channel)->max ?  refill(channel) : *((channel))->curr++)

#ifdef ANSI

extern value flush(struct channel *);
extern void putw(struct channel *, long);
extern unsigned char refill(struct channel *);
extern long getw(struct channel *);

#else

extern value flush();
extern void putw();
extern unsigned char refill();
extern long getw();

#endif

#define INTEXTERN_MAGIC_NUMBER 0x8495A6B7

